public abstract class Token {

    char type; // Typ des Tokens / Knotens
    int ord; // Reihenfolge fuer die Visualisierung

    public char type() { return type; } // Typ des Knotens
    public abstract int eval(); // Auswertung
    public abstract String prefix(); // Prefix-Darstellung
    public abstract String infix(); // Infix-Darstellung
    public abstract String postfix(); // Postfix-Darstellung
    public Token left() { return null; } // Linker Unterbaum
    public Token right() { return null; } // Rechter Unterbaum
    public int nodes() { return 1; } // Anzahl der Knoten des Baums
    public int depth() { return 1; } // Tiefe des Baums

    /**
     * Gibt die Reihenfolge des Knotens in der Infix-Darstellung zurueck (wichtig fuer die Visualisierung).
     * 
     * @return die Nummer des Knotens
     */
    public int ord() { return ord; }

    /**
     * Setzt die Nummer des Knotens in der Infix-Darstellung (wichtig fuer die Visualisierung).
     * 
     * @param o die Nummer des Knotens
     */
    public void setOrd(int o) { ord = o; }

    /**
     * Nummeriert den Baum ausgehend vom aktuellen Knoten unter Verwendung eines Zaehlers in Infix-Reihenfolge durch (wichtig fuer die Visualisierung).
     * 
     * @param o der Zaehler
     */
    public abstract void order(Order o);
    
}
